#include <u.h>
#include <libc.h>
#include "linux.h"

char *syscallname[] = {
	"setup",
	"exit",
	"fork",
	"read",
	"write",
	"open",
	"close",
	"waitpid",
	"creat",
	"link",
	"unlink",
	"execve",
	"chdir",
	"time",
	"mknod",
	"chmod",
	"lchown",
	"ni_syscall",
	"stat",
	"lseek",
	"getpid",
	"mount",
	"umount",
	"setuid",
	"getuid",
	"stime",
	"ptrace",
	"alarm",
	"fstat",
	"pause",
	"utime",
	"ni_syscall",
	"ni_syscall",
	"access",
	"nice",
	"ni_syscall",
	"sync",
	"kill",
	"rename",
	"mkdir",
	"rmdir",
	"dup",
	"pipe",
	"times",
	"ni_syscall",
	"brk",
	"setgid",
	"getgid",
	"signal",
	"geteuid",
	"getegid",
	"acct",
	"ni_syscall",
	"ni_syscall",
	"ioctl",
	"fcntl",
	"ni_syscall",
	"setpgid",
	"ni_syscall",
	"olduname",
	"umask",
	"chroot",
	"ustat",
	"dup2",
	"getppid",
	"getpgrp",
	"setsid",
	"sigaction",
	"sgetmask",
	"ssetmask",
	"setreuid",
	"setregid",
	"sigsuspend",
	"sigpending",
	"sethostname",
	"setrlimit",
	"getrlimit",
	"getrusage",
	"gettimeofday",
	"settimeofday",
	"getgroups",
	"setgroups",
	"old_select",
	"symlink",
	"lstat",
	"readlink",
	"uselib",
	"swapon",
	"reboot",
	"old_readdir",
	"old_mmap",
	"munmap",
	"truncate",
	"ftruncate",
	"fchmod",
	"fchown",
	"getpriority",
	"setpriority",
	"ni_syscall",
	"statfs",
	"fstatfs",
	"ioperm",
	"socketcall",
	"syslog",
	"setitimer",
	"getitimer",
	"newstat",
	"newlstat",
	"newfstat",
	"uname",
	"iopl",
	"vhangup",
	"idle",
	"vm86old",
	"wait4",
	"swapoff",
	"sysinfo",
	"ipc",
	"fsync",
	"sigreturn",
	"clone",
	"setdomainname",
	"newuname",
	"modify_ldt",
	"adjtimex",
	"mprotect",
	"sigprocmask",
	"create_module",
	"init_module",
	"delete_module",
	"get_kernel_syms",
	"quotactl",
	"getpgid",
	"fchdir",
	"bdflush",
	"sysfs",
	"personality",
	"ni_syscall",
	"setfsuid",
	"setfsgid",
	"llseek",
	"getdents",
	"select",
	"flock",
	"msync",
	"readv",
	"writev",
	"getsid",
	"fdatasync",
	"sysctl",
	"mlock",
	"munlock",
	"mlockall",
	"munlockall",
	"sched_setparam",
	"sched_getparam",
	"sched_setscheduler",
	"sched_getscheduler",
	"sched_yield",
	"sched_get_priority_max",
	"sched_get_priority_min",
	"sched_rr_get_interval",
	"nanosleep",
	"mremap",
	"setresuid",
	"getresuid",
	"vm86",
	"query_module",
	"poll",
	"nfsservctl",
	"setresgid",
	"getresgid",
	"prctl",
	"rt_sigreturn",
	"rt_sigaction",
	"rt_sigprocmask",
	"rt_sigpending",
	"rt_sigtimedwait",
	"rt_sigqueueinfo",
	"rt_sigsuspend",
	"pread",
	"pwrite",
	"chown",
	"getcwd",
	"capget",
	"capset",
	"signalstack",
	"sendfile",
	"getpmsg",
	"putpmsg",
	"vfork14",
	"ugetrlimit",
	"mmap2",
	"truncate64",
	"ftruncate64",
	"newstat64",
	"newlstat64",
	"fstat64",
	"newlchown",
	"newgetuid",
	"newgetgid",
	"newgeteuid",
	"newgetegid",
	"newsetreuid",
	"newsetregid",
	"newgetgroups",
	"newsetgroups",
	"newfchown",
	"newsetresuid",
	"newgetresuid",
	"newsetresgid",
	"newgetresgid",
	"newchown",
	"newsetuid",
	"newsetgid",
	"newsetfsuid",
	"newgetfsuid",
	"pivot_root",
	"mincore",
	"madvise",
	"getdents64",
	"fcntl64",
	"call222",
	"call223",
	"gettid",
	"readahead",
	"setxattr",
	"lsetxattr",
	"fsetxattr",
	"getxattr",
	"lgetxattr",
	"fgetxattr",
	"listxattr",
	"llistxatt",
	"rflistxattr",
	"removexattr",
	"lremovexattr",
	"fremovexattr",
	"tkill",
	"sendfile64",
	"futex",
	"sched_setaffinity",
	"sched_getaffinity",
	"set_thread_area",
	"get_thread_area",
	"io_setup",
	"io_destroy",
	"io_getevents",
	"io_submit",
	"io_cancel",
	"fadvise64",
	"call251",
	"exit_group",
	"lookup_dcookie",
	"epoll_create",
	"epoll_ctl",
	"epoll_wait",
	"remap_file_pages",
	"set_tid_address",
	"timer_create",
	"timer_settime",
	"timer_gettime",
	"timer_getoverrun",
	"timer_delete",
	"clock_settime",
	"clock_gettime",
	"clock_getres",
	"clock_nanosleep",
	"statfs64",
	"fstatfs64",
	"tgkill",
	"utimes",
	"fadvise64_64",
	"vserver",
};

Ioctlname ioctlname[] = {
	{0x00008901, "FIOSETOWN"},
	{0x00008902, "SIOCSPGRP"},
	{0x00008903, "FIOGETOWN"},
	{0x00008904, "SIOCGPGRP"},
	{0x00008905, "SIOCATMARK"},
	{0x00008906, "SIOCGSTAMP"},
	{0x00005401, "TCGETS"},
	{0x00005402, "TCSETS"},
	{0x00005403, "TCSETSW"},
	{0x00005404, "TCSETSF"},
	{0x00005405, "TCGETA"},
	{0x00005406, "TCSETA"},
	{0x00005407, "TCSETAW"},
	{0x00005408, "TCSETAF"},
	{0x00005409, "TCSBRK"},
	{0x0000540A, "TCXONC"},
	{0x0000540B, "TCFLSH"},
	{0x0000540C, "TIOCEXCL"},
	{0x0000540D, "TIOCNXCL"},
	{0x0000540E, "TIOCSCTTY"},
	{0x0000540F, "TIOCGPGRP"},
	{0x00005410, "TIOCSPGRP"},
	{0x00005411, "TIOCOUTQ"},
	{0x00005412, "TIOCSTI"},
	{0x00005413, "TIOCGWINSZ"},
	{0x00005414, "TIOCSWINSZ"},
	{0x00005415, "TIOCMGET"},
	{0x00005416, "TIOCMBIS"},
	{0x00005417, "TIOCMBIC"},
	{0x00005418, "TIOCMSET"},
	{0x00005419, "TIOCGSOFTCAR"},
	{0x0000541A, "TIOCSSOFTCAR"},
	{0x0000541B, "FIONREAD"},
	{0x0000541B, "TIOCINQ"},
	{0x0000541C, "TIOCLINUX"},
	{0x0000541D, "TIOCCONS"},
	{0x0000541E, "TIOCGSERIAL"},
	{0x0000541F, "TIOCSSERIAL"},
	{0x00005420, "TIOCPKT"},
	{0x00005421, "FIONBIO"},
	{0x00005422, "TIOCNOTTY"},
	{0x00005423, "TIOCSETD"},
	{0x00005424, "TIOCGETD"},
	{0x00005425, "TCSBRKP"},
	{0x00005426, "TIOCTTYGSTRUCT"},
	{0x00005450, "FIONCLEX"},
	{0x00005451, "FIOCLEX"},
	{0x00005452, "FIOASYNC"},
	{0x00005453, "TIOCSERCONFIG"},
	{0x00005454, "TIOCSERGWILD"},
	{0x00005455, "TIOCSERSWILD"},
	{0x00005456, "TIOCGLCKTRMIOS"},
	{0x00005457, "TIOCSLCKTRMIOS"},
	{0x00005458, "TIOCSERGSTRUCT"},
	{0x00005459, "TIOCSERGETLSR"},
	{0x0000545A, "TIOCSERGETMULTI"},
	{0x0000545B, "TIOCSERSETMULTI"},
	{0x000089E0, "SIOCAX25GETUID"},
	{0x000089E1, "SIOCAX25ADDUID"},
	{0x000089E2, "SIOCAX25DELUID"},
	{0x000089E3, "SIOCAX25NOUID"},
	{0x000089E4, "SIOCAX25DIGCTL"},
	{0x000089E5, "SIOCAX25GETPARMS"},
	{0x000089E6, "SIOCAX25SETPARMS"},
	{0x00007314, "STL_BINTR"},
	{0x00007315, "STL_BSTART"},
	{0x00007316, "STL_BSTOP"},
	{0x00007317, "STL_BRESET"},
	{0x00005301, "CDROMPAUSE"},
	{0x00005302, "CDROMRESUME"},
	{0x00005303, "CDROMPLAYMSF"},
	{0x00005304, "CDROMPLAYTRKIND"},
	{0x00005305, "CDROMREADTOCHDR"},
	{0x00005306, "CDROMREADTOCENTRY"},
	{0x00005307, "CDROMSTOP"},
	{0x00005308, "CDROMSTART"},
	{0x00005309, "CDROMEJECT"},
	{0x0000530A, "CDROMVOLCTRL"},
	{0x0000530B, "CDROMSUBCHNL"},
	{0x0000530C, "CDROMREADMODE2"},
	{0x0000530D, "CDROMREADMODE1"},
	{0x0000530E, "CDROMREADAUDIO"},
	{0x0000530F, "CDROMEJECT_SW"},
	{0x00005310, "CDROMMULTISESSION"},
	{0x00005311, "CDROM_GET_UPC"},
	{0x00005312, "CDROMRESET"},
	{0x00005313, "CDROMVOLREAD"},
	{0x00005314, "CDROMREADRAW"},
	{0x00005315, "CDROMREADCOOKED"},
	{0x00005316, "CDROMSEEK"},
	{0x00002000, "CM206CTL_GET_STAT"},
	{0x00002001, "CM206CTL_GET_LAST_STAT"},
	{0x00435901, "CYGETMON"},
	{0x00435902, "CYGETTHRESH"},
	{0x00435903, "CYSETTHRESH"},
	{0x00435904, "CYGETDEFTHRESH"},
	{0x00435905, "CYSETDEFTHRESH"},
	{0x00435906, "CYGETTIMEOUT"},
	{0x00435907, "CYSETTIMEOUT"},
	{0x00435908, "CYGETDEFTIMEOUT"},
	{0x00435909, "CYSETDEFTIMEOUT"},
	{0x80046601, "EXT2_IOC_GETFLAGS"},
	{0x40046602, "EXT2_IOC_SETFLAGS"},
	{0x80047601, "EXT2_IOC_GETVERSION"},
	{0x40047602, "EXT2_IOC_SETVERSION"},
	{0x00000000, "FDCLRPRM"},
	{0x00000001, "FDSETPRM"},
	{0x00000002, "FDDEFPRM"},
	{0x00000003, "FDGETPRM"},
	{0x00000004, "FDMSGON"},
	{0x00000005, "FDMSGOFF"},
	{0x00000006, "FDFMTBEG"},
	{0x00000007, "FDFMTTRK"},
	{0x00000008, "FDFMTEND"},
	{0x0000000A, "FDSETEMSGTRESH"},
	{0x0000000B, "FDFLUSH"},
	{0x0000000C, "FDSETMAXERRS"},
	{0x0000000E, "FDGETMAXERRS"},
	{0x00000010, "FDGETDRVTYP"},
	{0x00000014, "FDSETDRVPRM"},
	{0x00000015, "FDGETDRVPRM"},
	{0x00000016, "FDGETDRVSTAT"},
	{0x00000017, "FDPOLLDRVSTAT"},
	{0x00000018, "FDRESET"},
	{0x00000019, "FDGETFDCSTAT"},
	{0x0000001B, "FDWERRORCLR"},
	{0x0000001C, "FDWERRORGET"},
	{0x0000001E, "FDRAWCMD"},
	{0x00000028, "FDTWADDLE"},
	{0x0000125D, "BLKROSET"},
	{0x0000125E, "BLKROGET"},
	{0x0000125F, "BLKRRPART"},
	{0x00001260, "BLKGETSIZE"},
	{0x00001261, "BLKFLSBUF"},
	{0x00001262, "BLKRASET"},
	{0x00001263, "BLKRAGET"},
	{0x00000001, "FIBMAP"},
	{0x00000002, "FIGETBSZ"},
	{0x00000301, "HDIO_GETGEO"},
	{0x00000302, "HDIO_GET_UNMASKINTR"},
	{0x00000304, "HDIO_GET_MULTCOUNT"},
	{0x00000307, "HDIO_GET_IDENTITY"},
	{0x00000308, "HDIO_GET_KEEPSETTINGS"},
	{0x00000309, "HDIO_GET_CHIPSET"},
	{0x0000030A, "HDIO_GET_NOWERR"},
	{0x0000030B, "HDIO_GET_DMA"},
	{0x0000031F, "HDIO_DRIVE_CMD"},
	{0x00000321, "HDIO_SET_MULTCOUNT"},
	{0x00000322, "HDIO_SET_UNMASKINTR"},
	{0x00000323, "HDIO_SET_KEEPSETTINGS"},
	{0x00000324, "HDIO_SET_CHIPSET"},
	{0x00000325, "HDIO_SET_NOWERR"},
	{0x00000326, "HDIO_SET_DMA"},
	{0x000089F0, "EQL_ENSLAVE"},
	{0x000089F1, "EQL_EMANCIPATE"},
	{0x000089F2, "EQL_GETSLAVECFG"},
	{0x000089F3, "EQL_SETSLAVECFG"},
	{0x000089F4, "EQL_GETMASTRCFG"},
	{0x000089F5, "EQL_SETMASTRCFG"},
	{0x000089F0, "SIOCDEVPLIP"},
	{0x00005490, "PPPIOCGFLAGS"},
	{0x00005491, "PPPIOCSFLAGS"},
	{0x00005492, "PPPIOCGASYNCMAP"},
	{0x00005493, "PPPIOCSASYNCMAP"},
	{0x00005494, "PPPIOCGUNIT"},
	{0x00005495, "PPPIOCSINPSIG"},
	{0x00005497, "PPPIOCSDEBUG"},
	{0x00005498, "PPPIOCGDEBUG"},
	{0x00005499, "PPPIOCGSTAT"},
	{0x0000549A, "PPPIOCGTIME"},
	{0x0000549B, "PPPIOCGXASYNCMAP"},
	{0x0000549C, "PPPIOCSXASYNCMAP"},
	{0x0000549D, "PPPIOCSMRU"},
	{0x0000549E, "PPPIOCRASYNCMAP"},
	{0x0000549F, "PPPIOCSMAXCID"},
	{0x000089E0, "SIOCAIPXITFCRT"},
	{0x000089E1, "SIOCAIPXPRISLT"},
	{0x000089E2, "SIOCIPXCFGDATA"},
	{0x00004B60, "GIO_FONT"},
	{0x00004B61, "PIO_FONT"},
	{0x00004B6B, "GIO_FONTX"},
	{0x00004B6C, "PIO_FONTX"},
	{0x00004B70, "GIO_CMAP"},
	{0x00004B71, "PIO_CMAP"},
	{0x00004B2F, "KIOCSOUND"},
	{0x00004B30, "KDMKTONE"},
	{0x00004B31, "KDGETLED"},
	{0x00004B32, "KDSETLED"},
	{0x00004B33, "KDGKBTYPE"},
	{0x00004B34, "KDADDIO"},
	{0x00004B35, "KDDELIO"},
	{0x00004B36, "KDENABIO"},
	{0x00004B37, "KDDISABIO"},
	{0x00004B3A, "KDSETMODE"},
	{0x00004B3B, "KDGETMODE"},
	{0x00004B3C, "KDMAPDISP"},
	{0x00004B3D, "KDUNMAPDISP"},
	{0x00004B40, "GIO_SCRNMAP"},
	{0x00004B41, "PIO_SCRNMAP"},
	{0x00004B69, "GIO_UNISCRNMAP"},
	{0x00004B6A, "PIO_UNISCRNMAP"},
	{0x00004B66, "GIO_UNIMAP"},
	{0x00004B67, "PIO_UNIMAP"},
	{0x00004B68, "PIO_UNIMAPCLR"},
	{0x00004B44, "KDGKBMODE"},
	{0x00004B45, "KDSKBMODE"},
	{0x00004B62, "KDGKBMETA"},
	{0x00004B63, "KDSKBMETA"},
	{0x00004B64, "KDGKBLED"},
	{0x00004B65, "KDSKBLED"},
	{0x00004B46, "KDGKBENT"},
	{0x00004B47, "KDSKBENT"},
	{0x00004B48, "KDGKBSENT"},
	{0x00004B49, "KDSKBSENT"},
	{0x00004B4A, "KDGKBDIACR"},
	{0x00004B4B, "KDSKBDIACR"},
	{0x00004B4C, "KDGETKEYCODE"},
	{0x00004B4D, "KDSETKEYCODE"},
	{0x00004B4E, "KDSIGACCEPT"},
	{0x00000601, "LPCHAR"},
	{0x00000602, "LPTIME"},
	{0x00000604, "LPABORT"},
	{0x00000605, "LPSETIRQ"},
	{0x00000606, "LPGETIRQ"},
	{0x00000608, "LPWAIT"},
	{0x00000609, "LPCAREFUL"},
	{0x0000060A, "LPABORTOPEN"},
	{0x0000060B, "LPGETSTATUS"},
	{0x0000060C, "LPRESET"},
	{0x0000060D, "LPGETSTATS"},
	{0x000089E0, "SIOCGETVIFCNT"},
	{0x000089E1, "SIOCGETSGCNT"},
	{0x40086D01, "MTIOCTOP"},
	{0x801C6D02, "MTIOCGET"},
	{0x80046D03, "MTIOCPOS"},
	{0x80206D04, "MTIOCGETCONFIG"},
	{0x40206D05, "MTIOCSETCONFIG"},
	{0x000089E0, "SIOCNRGETPARMS"},
	{0x000089E1, "SIOCNRSETPARMS"},
	{0x000089E2, "SIOCNRDECOBS"},
	{0x000089E3, "SIOCNRRTCTL"},
	{0x00009000, "DDIOCSDBG"},
	{0x00005382, "CDROMAUDIOBUFSIZ"},
	{0x00005470, "TIOCSCCINI"},
	{0x00005471, "TIOCCHANINI"},
	{0x00005472, "TIOCGKISS"},
	{0x00005473, "TIOCSKISS"},
	{0x00005474, "TIOCSCCSTAT"},
	{0x00005382, "SCSI_IOCTL_GET_IDLUN"},
	{0x00005383, "SCSI_IOCTL_TAGGED_ENABLE"},
	{0x00005384, "SCSI_IOCTL_TAGGED_DISABLE"},
	{0x00005385, "SCSI_IOCTL_PROBE_HOST"},
	{0x80027501, "SMB_IOC_GETMOUNTUID"},
	{0x0000890B, "SIOCADDRT"},
	{0x0000890C, "SIOCDELRT"},
	{0x00008910, "SIOCGIFNAME"},
	{0x00008911, "SIOCSIFLINK"},
	{0x00008912, "SIOCGIFCONF"},
	{0x00008913, "SIOCGIFFLAGS"},
	{0x00008914, "SIOCSIFFLAGS"},
	{0x00008915, "SIOCGIFADDR"},
	{0x00008916, "SIOCSIFADDR"},
	{0x00008917, "SIOCGIFDSTADDR"},
	{0x00008918, "SIOCSIFDSTADDR"},
	{0x00008919, "SIOCGIFBRDADDR"},
	{0x0000891A, "SIOCSIFBRDADDR"},
	{0x0000891B, "SIOCGIFNETMASK"},
	{0x0000891C, "SIOCSIFNETMASK"},
	{0x0000891D, "SIOCGIFMETRIC"},
	{0x0000891E, "SIOCSIFMETRIC"},
	{0x0000891F, "SIOCGIFMEM"},
	{0x00008920, "SIOCSIFMEM"},
	{0x00008921, "SIOCGIFMTU"},
	{0x00008922, "SIOCSIFMTU"},
	{0x00008923, "OLD_SIOCGIFHWADDR"},
	{0x00008924, "SIOCSIFHWADDR"},
	{0x00008925, "SIOCGIFENCAP"},
	{0x00008926, "SIOCSIFENCAP"},
	{0x00008927, "SIOCGIFHWADDR"},
	{0x00008929, "SIOCGIFSLAVE"},
	{0x00008930, "SIOCSIFSLAVE"},
	{0x00008931, "SIOCADDMULTI"},
	{0x00008932, "SIOCDELMULTI"},
	{0x00008940, "SIOCADDRTOLD"},
	{0x00008941, "SIOCDELRTOLD"},
	{0x00008950, "SIOCDARP"},
	{0x00008951, "SIOCGARP"},
	{0x00008952, "SIOCSARP"},
	{0x00008960, "SIOCDRARP"},
	{0x00008961, "SIOCGRARP"},
	{0x00008962, "SIOCSRARP"},
	{0x00008970, "SIOCGIFMAP"},
	{0x00008971, "SIOCSIFMAP"},
	{0x00005100, "SNDCTL_SEQ_RESET"},
	{0x00005101, "SNDCTL_SEQ_SYNC"},
	{0xC08C5102, "SNDCTL_SYNTH_INFO"},
	{0xC0045103, "SNDCTL_SEQ_CTRLRATE"},
	{0x80045104, "SNDCTL_SEQ_GETOUTCOUNT"},
	{0x80045105, "SNDCTL_SEQ_GETINCOUNT"},
	{0x40045106, "SNDCTL_SEQ_PERCMODE"},
	{0x40285107, "SNDCTL_FM_LOAD_INSTR"},
	{0x40045108, "SNDCTL_SEQ_TESTMIDI"},
	{0x40045109, "SNDCTL_SEQ_RESETSAMPLES"},
	{0x8004510A, "SNDCTL_SEQ_NRSYNTHS"},
	{0x8004510B, "SNDCTL_SEQ_NRMIDIS"},
	{0xC074510C, "SNDCTL_MIDI_INFO"},
	{0x4004510D, "SNDCTL_SEQ_THRESHOLD"},
	{0xC004510E, "SNDCTL_SYNTH_MEMAVL"},
	{0x4004510F, "SNDCTL_FM_4OP_ENABLE"},
	{0xCFB85110, "SNDCTL_PMGR_ACCESS"},
	{0x00005111, "SNDCTL_SEQ_PANIC"},
	{0x40085112, "SNDCTL_SEQ_OUTOFBAND"},
	{0xC0045401, "SNDCTL_TMR_TIMEBASE"},
	{0x00005402, "SNDCTL_TMR_START"},
	{0x00005403, "SNDCTL_TMR_STOP"},
	{0x00005404, "SNDCTL_TMR_CONTINUE"},
	{0xC0045405, "SNDCTL_TMR_TEMPO"},
	{0xC0045406, "SNDCTL_TMR_SOURCE"},
	{0x40045407, "SNDCTL_TMR_METRONOME"},
	{0x40045408, "SNDCTL_TMR_SELECT"},
	{0xCFB85001, "SNDCTL_PMGR_IFACE"},
	{0xC0046D00, "SNDCTL_MIDI_PRETIME"},
	{0xC0046D01, "SNDCTL_MIDI_MPUMODE"},
	{0xC0216D02, "SNDCTL_MIDI_MPUCMD"},
	{0x00005000, "SNDCTL_DSP_RESET"},
	{0x00005001, "SNDCTL_DSP_SYNC"},
	{0xC0045002, "SNDCTL_DSP_SPEED"},
	{0xC0045003, "SNDCTL_DSP_STEREO"},
	{0xC0045004, "SNDCTL_DSP_GETBLKSIZE"},
	{0xC0045006, "SOUND_PCM_WRITE_CHANNELS"},
	{0xC0045007, "SOUND_PCM_WRITE_FILTER"},
	{0x00005008, "SNDCTL_DSP_POST"},
	{0xC0045009, "SNDCTL_DSP_SUBDIVIDE"},
	{0xC004500A, "SNDCTL_DSP_SETFRAGMENT"},
	{0x8004500B, "SNDCTL_DSP_GETFMTS"},
	{0xC0045005, "SNDCTL_DSP_SETFMT"},
	{0x800C500C, "SNDCTL_DSP_GETOSPACE"},
	{0x800C500D, "SNDCTL_DSP_GETISPACE"},
	{0x0000500E, "SNDCTL_DSP_NONBLOCK"},
	{0x80045002, "SOUND_PCM_READ_RATE"},
	{0x80045006, "SOUND_PCM_READ_CHANNELS"},
	{0x80045005, "SOUND_PCM_READ_BITS"},
	{0x80045007, "SOUND_PCM_READ_FILTER"},
	{0x00004300, "SNDCTL_COPR_RESET"},
	{0xCFB04301, "SNDCTL_COPR_LOAD"},
	{0xC0144302, "SNDCTL_COPR_RDATA"},
	{0xC0144303, "SNDCTL_COPR_RCODE"},
	{0x40144304, "SNDCTL_COPR_WDATA"},
	{0x40144305, "SNDCTL_COPR_WCODE"},
	{0xC0144306, "SNDCTL_COPR_RUN"},
	{0xC0144307, "SNDCTL_COPR_HALT"},
	{0x4FA44308, "SNDCTL_COPR_SENDMSG"},
	{0x8FA44309, "SNDCTL_COPR_RCVMSG"},
	{0x80044D00, "SOUND_MIXER_READ_VOLUME"},
	{0x80044D01, "SOUND_MIXER_READ_BASS"},
	{0x80044D02, "SOUND_MIXER_READ_TREBLE"},
	{0x80044D03, "SOUND_MIXER_READ_SYNTH"},
	{0x80044D04, "SOUND_MIXER_READ_PCM"},
	{0x80044D05, "SOUND_MIXER_READ_SPEAKER"},
	{0x80044D06, "SOUND_MIXER_READ_LINE"},
	{0x80044D07, "SOUND_MIXER_READ_MIC"},
	{0x80044D08, "SOUND_MIXER_READ_CD"},
	{0x80044D09, "SOUND_MIXER_READ_IMIX"},
	{0x80044D0A, "SOUND_MIXER_READ_ALTPCM"},
	{0x80044D0B, "SOUND_MIXER_READ_RECLEV"},
	{0x80044D0C, "SOUND_MIXER_READ_IGAIN"},
	{0x80044D0D, "SOUND_MIXER_READ_OGAIN"},
	{0x80044D0E, "SOUND_MIXER_READ_LINE1"},
	{0x80044D0F, "SOUND_MIXER_READ_LINE2"},
	{0x80044D10, "SOUND_MIXER_READ_LINE3"},
	{0x80044D1C, "SOUND_MIXER_READ_MUTE"},
	{0x80044D1D, "SOUND_MIXER_READ_ENHANCE"},
	{0x80044D1E, "SOUND_MIXER_READ_LOUD"},
	{0x80044DFF, "SOUND_MIXER_READ_RECSRC"},
	{0x80044DFE, "SOUND_MIXER_READ_DEVMASK"},
	{0x80044DFD, "SOUND_MIXER_READ_RECMASK"},
	{0x80044DFB, "SOUND_MIXER_READ_STEREODEVS"},
	{0x80044DFC, "SOUND_MIXER_READ_CAPS"},
	{0xC0044D00, "SOUND_MIXER_WRITE_VOLUME"},
	{0xC0044D01, "SOUND_MIXER_WRITE_BASS"},
	{0xC0044D02, "SOUND_MIXER_WRITE_TREBLE"},
	{0xC0044D03, "SOUND_MIXER_WRITE_SYNTH"},
	{0xC0044D04, "SOUND_MIXER_WRITE_PCM"},
	{0xC0044D05, "SOUND_MIXER_WRITE_SPEAKER"},
	{0xC0044D06, "SOUND_MIXER_WRITE_LINE"},
	{0xC0044D07, "SOUND_MIXER_WRITE_MIC"},
	{0xC0044D08, "SOUND_MIXER_WRITE_CD"},
	{0xC0044D09, "SOUND_MIXER_WRITE_IMIX"},
	{0xC0044D0A, "SOUND_MIXER_WRITE_ALTPCM"},
	{0xC0044D0B, "SOUND_MIXER_WRITE_RECLEV"},
	{0xC0044D0C, "SOUND_MIXER_WRITE_IGAIN"},
	{0xC0044D0D, "SOUND_MIXER_WRITE_OGAIN"},
	{0xC0044D0E, "SOUND_MIXER_WRITE_LINE1"},
	{0xC0044D0F, "SOUND_MIXER_WRITE_LINE2"},
	{0xC0044D10, "SOUND_MIXER_WRITE_LINE3"},
	{0xC0044D1C, "SOUND_MIXER_WRITE_MUTE"},
	{0xC0044D1D, "SOUND_MIXER_WRITE_ENHANCE"},
	{0xC0044D1E, "SOUND_MIXER_WRITE_LOUD"},
	{0xC0044DFF, "SOUND_MIXER_WRITE_RECSRC"},
	{0x000004D2, "UMSDOS_READDIR_DOS"},
	{0x000004D3, "UMSDOS_UNLINK_DOS"},
	{0x000004D4, "UMSDOS_RMDIR_DOS"},
	{0x000004D5, "UMSDOS_STAT_DOS"},
	{0x000004D6, "UMSDOS_CREAT_EMD"},
	{0x000004D7, "UMSDOS_UNLINK_EMD"},
	{0x000004D8, "UMSDOS_READDIR_EMD"},
	{0x000004D9, "UMSDOS_GETVERSION"},
	{0x000004DA, "UMSDOS_INIT_EMD"},
	{0x000004DB, "UMSDOS_DOS_SETUP"},
	{0x000004DC, "UMSDOS_RENAME_DOS"},
	{0x00005600, "VT_OPENQRY"},
	{0x00005601, "VT_GETMODE"},
	{0x00005602, "VT_SETMODE"},
	{0x00005603, "VT_GETSTATE"},
	{0x00005604, "VT_SENDSIG"},
	{0x00005605, "VT_RELDISP"},
	{0x00005606, "VT_ACTIVATE"},
	{0x00005607, "VT_WAITACTIVE"},
	{0x00005608, "VT_DISALLOCATE"},
	{0x00005609, "VT_RESIZE"},
	{0x0000560A, "VT_RESIZEX"},
	{0, 0},
};
